gtkmm: Gtk::CallbackAction Class Reference

gtkmm 4.8.0

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gtk::CallbackAction Class Reference

A Gtk::ShortcutAction that invokes a callback. More...

`#include <gtkmm/shortcutaction.h>`

Inheritance diagram for Gtk::CallbackAction:
[legend]

## Public Types
using | SlotShortcut = sigc::slot< bool(Widget &, const Glib::VariantBase &)>
| Slot for shortcuts based on user callbacks. More...
Public Types inherited from Gtk::ShortcutAction
enum class | Flags { Flags::EXCLUSIVE = 1 << 0 }
| List of flags that can be passed to action activation. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)

## Public Member Functions
| CallbackAction (CallbackAction && src) noexcept
CallbackAction & | operator= (CallbackAction && src) noexcept
| ~CallbackAction () noexcept override
GtkCallbackAction * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkCallbackAction * | gobj () const
| Provides access to the underlying C GObject. More...
GtkCallbackAction * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Public Member Functions inherited from Gtk::ShortcutAction
| ShortcutAction (ShortcutAction && src) noexcept
ShortcutAction & | operator= (ShortcutAction && src) noexcept
| ~ShortcutAction () noexcept override
GtkShortcutAction * | gobj ()
| Provides access to the underlying C GObject. More...
const GtkShortcutAction * | gobj () const
| Provides access to the underlying C GObject. More...
GtkShortcutAction * | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::ustring | to_string () const
| Prints the given action into a human-readable string. More...
bool | activate (Widget & widget, Flags flags=static_cast< Flags >(0), const Glib::VariantBase & args={})
| Activates the action on the widget with the given args. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
PropertyType | get_property (const Glib::ustring &property_name) const
sigc::connection | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void()> &slot)
sigc::connection | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void()> &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< CallbackAction > | create (const SlotShortcut & slot)
Static Public Member Functions inherited from Gtk::ShortcutAction
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< ShortcutAction > | parse_string (const Glib::ustring &string)
| Tries to parse the given string into an action. More...

## Protected Member Functions
| CallbackAction (const SlotShortcut & slot)
Protected Member Functions inherited from Gtk::ShortcutAction
| ShortcutAction ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gtk::CallbackAction > | wrap (GtkCallbackAction * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::ShortcutAction
Glib::RefPtr< Gtk::ShortcutAction > | wrap (GtkShortcutAction * object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Detailed Description

A Gtk::ShortcutAction that invokes a callback.

## Member Typedef Documentation

## ◆ SlotShortcut

using Gtk::CallbackAction::SlotShortcut = sigc::slot<bool(Widget&, const Glib::VariantBase&)>

Slot for shortcuts based on user callbacks.

For instance:

void on_shortcut(Widget& widget, const Glib::VariantBase& args);
Glib::VariantBase

Parameters

  widget | The widget passed to the activation.
  args | The arguments passed to the activation. Can be empty, if there are no arguments.

## Constructor & Destructor Documentation

## ◆ CallbackAction() [1/2]

Gtk::CallbackAction::CallbackAction | ( | CallbackAction && | src | ) |
| noexcept

## ◆ ~CallbackAction()

Gtk::CallbackAction::~CallbackAction | ( |  | ) |
| overridenoexcept

## ◆ CallbackAction() [2/2]

Gtk::CallbackAction::CallbackAction | ( | const SlotShortcut & | slot | ) |
| explicitprotected

## Member Function Documentation

## ◆ create()

static Glib::RefPtr< CallbackAction > Gtk::CallbackAction::create | ( | const SlotShortcut & | slot | ) |
| static

## ◆ get_type()

static GType Gtk::CallbackAction::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkCallbackAction * Gtk::CallbackAction::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkCallbackAction * Gtk::CallbackAction::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GtkCallbackAction * Gtk::CallbackAction::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

CallbackAction & Gtk::CallbackAction::operator= | ( | CallbackAction && | src | ) |
| noexcept

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gtk::CallbackAction > wrap | ( | GtkCallbackAction * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.